//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           fmul.asm                                       //
//                                                                          //
//        32  (float)      //
// FMul -  2 float   32 .                          //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .     .

global FMul: label;

extern FFrExp           :label;
extern FResult          :label;
extern FPIEEE_Signal    :label;

import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();

begin text

//=====  FMul =================================
//     . 32- 
//    .
//  :     .
// +0 = SP    
// -1 =  , float 32 
// -2 =  , float 32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - , float 32 
// : ar5
<FMul>
        //  ,  gr5
    pop ar5,gr5 with gr7 = gr5;     // ar5 -  , gr5 - 

        //  
    push ar0,gr0 with gr0 = gr5;    // gr0 -  
    push ar1,gr1 with gr5 = gr7;    //    gr5
    push ar2,gr2;
    push ar3,gr3;
    push ar4,gr4 with gr4 = gr0;    // gr4 -  
    push ar5,gr5;
    gr5 = ar5;                      // gr5 -  

    push ar4, gr4;          //  FFrExp
    call FFrExp;
    pop ar2,gr2             // gr2 -   
        with gr7;           // ar2 -   
    gr0 = ar2;              // gr0 -   
    if <>0 delayed skip Abnormal1
        with gr4 = gr4 xor gr5 noflags;     //  
    push ar5, gr5;          //  FFrExp
    nul;
    // cond. skip Abnormal1

    call FFrExp;
    pop ar3,gr3 with gr7;   // gr3 -   
                            // ar3 -   
    gr7 = ar3               // gr7 -   
        with gr2 = gr2 + gr3 noflags;   //  
    if <>0 skip Abnormal2;  //    gr7

        //  
    gr3 = 124
        with gr1 = gr0 *: gr7;
.repeat 12;
    gr1 = gr0 * gr7;
.endrepeat;

        //  
    delayed call FResult
        with gr2 -= gr3;
    with gr0 = gr7;
    with gr3 = false;
    // call FResult;
<Ret>
    pop ar5,gr5;
    pop ar4,gr4;
    pop ar3,gr3;
    pop ar2,gr2;
    pop ar1,gr1;
    pop ar0,gr0;
    return;

<Abnormal1>
    call FFrExp
        with gr5 = gr7;     //    
    pop ar1,gr1             
        with gr5;
    gr1 = ar1;              //   
    if < skip NaN1
        with gr7;
    if < skip NaN2;
    if > skip Inf
        with gr1;
    if <>0 skip Inf;

<Invalid>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    skip Ret;
        gr7 = true;    // quiet NaN
    // skip Ret;

<Abnormal2>
    with gr7;
    if < skip NaN2
        with gr0;
    if =0 skip Invalid;

<Inf>
    gr7 = 7f800000h
        with gr4 >>= 31;
    delayed skip Ret
        with gr4 <<= 31;
    gr7 = gr7 or gr4;
    nul;
    // skip Ret;

<NaN1>
    with gr5 + 1;
    if <>0 skip Invalid;    // signaling NaN
<NaN2>
    with gr7 + 1;
    gr7 = true noflags;
    if >= skip Ret;
    skip Invalid;   // signaling NaN

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         fmul.asm                               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
