//////////////////////////////////////////////////////////////////////////
//                                                                      //
// logf.cpp -                                                          //
//                                                                      //
//                              //
//        .                          //
//                                                                      //
// Copyright (c) 2001 RC Module Inc.                                    //
//                                                                      //
//  :  ..                                                 //
//                                                                      //
//   $Revision:: 1     $      $Date:: 2/14/06 8:08p    $                //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "math.h"
#include "auxfd.h"

#ifdef __cplusplus
extern "C" {
#endif

//  Ln(1+1/2)*c, Ln(1+1/4)*c, Ln(1+1/8)*c, ...
//  c = 040000000
extern int _TLN[29];
const int _TLN2 = 0x2C5C85FE;

//    
//	    ln(x) = ln(~=2)+ln(2^(-1)) = ln(~=2)-ln(2)
unsigned int _TMLN[28] ={	0x12696211,	0x11178e82,	0x108598b5,	0x10415d89,	0x10205658,
				0x10101575,	0x10080559,	0x10040155,	0x10020055,	0x10010015,
				0x10008005,	0x10004001,	0x10002000,	0x10001000,	0x10000800,
				0x10000400,	0x10000200,	0x10000100,	0x10000080,	0x10000040,
				0x10000020,	0x10000010,	0x10000008,	0x10000004,	0x10000002,
				0x10000001,	0x10000000,	0x10000000	};

// logf --
//
//    
//
//    --.
//    CORDIC,    .
float logf(float f){

	int Mnt;                            //   
    int Exp, Sgn;                       //     
    int Spc;
    int NewExp;                         //   
	unsigned int Arg;                   //     

    //   float
    DestructFloat( f, Mnt, Exp, Sgn, Spc );

	//  
	if ( Exp ==128 || Sgn==1 )	// -x, +inf, NAN:  NAN
		return ConstructFloat( 1, 0x80, 0, 0);

	if ( Mnt ==0 && Exp == -127 )	// 0 -> +inf
		return ConstructFloat( 0, 0x80, 0, 0);

	if (!(Mnt & 0x00800000)){  //  
		Exp++;
		while (!(Mnt & 0x00800000)){
			Mnt <<=1;
			Exp--;
		}
	}

	Mnt <<= 7;
	unsigned int tmp;   //       
	int rez = 0;
	Arg= 0x40000000;    /*   1,  
								        */
	NewExp = 0;
	int i=0,j=0;

	tmp = Arg;

    //      ln(x) = ln(~=2)+ln(2^(-1)) = ln(~=2)-ln(2)
    if (Exp==-1){
		Mnt>>=1;
		while (i<=27){  
			i++;
			tmp -= (tmp>>(i+1));
			if (tmp>=Mnt){
				if (j==0){
					j=i;
					NewExp=-j+1;
					rez<<=j;
				}
				Arg = tmp;
				rez += _TMLN[i-1]>>(i-j);
				tmp -= (tmp>>(i+1));
				if (tmp>=Mnt){
					Arg = tmp;
					rez += _TMLN[i-1]>>(i-j);
				}
				else
					tmp = Arg;
			}
			else
				tmp = Arg;

		}
		Exp=0;
		Sgn=1;
	}
	else    
        //     
		while (i<=28){  
			i++;
			tmp += tmp>>i; 
			if (tmp<=Mnt){
				Arg = tmp;
				rez += _TLN[i-1];
			}
			else 
				tmp = Arg;
		}
	
	if (Exp<-1){
		rez = -rez;
		Exp = -Exp;
		Sgn=1;
	}

	i=0;
	int NewMnt = rez;
    //   :   log(2x) = log2 + log(x)
	while (Exp>0){  
		i++;
		if (Exp & 1){
			NewMnt += _TLN2;
			rez = NewMnt;
			rez >>=1;
			NewExp = i;
		}
		Exp>>=1;
		NewMnt>>=1;
	}
	if (rez & 0x40000000)
		rez >>=1;
	else
		NewExp--;

    if (rez){
		while (!(rez & 0x20000000)){
			rez <<=1;
			NewExp--;
		}
    }
    else
    {
        NewExp= -127;    
    }

	rez >>=5;	                    //    , ...
	rez = (rez>>1) + (rez & 1);     //   ,  .

	if (rez == 0x01000000){	
		rez = 0;
		NewExp++;
	}

    //   float
    return ConstructFloat( rez, NewExp, Sgn, 0);
}

#ifdef __cplusplus
}
#endif
