//----------------------------------------------------------------
//
// Copyright 1998 (c) RC Module Inc.
// NeuroChip NM6403.
//
// nc_load.h
// Header file for synchronization and exchange library for 
// PCI Dual NM6403 Board.
// Contain functions for exchange with Host PC and other NM6403 processor.
// ver 1.0.
//
// by Alexey A. Chelubeev
//
//----------------------------------------------------------------

#ifndef _NC_LOAD_H
#define _NC_LOAD_H

#include <stdlib.h>

#define NC_SYNC "1.0"
#define NC_SYNC_MAJOR_VERSION 1
#define NC_SYNC_MINOR_VERSION 0

extern "C" {

        // return processor number on board.
    int ncl_getProcessorNo( void );

        // Barrier sync with host PC.
    int ncl_hostSync( int value );

        // Barrier sync with host PC with array exchange.
    int ncl_hostSyncArray( 
            int value,          // Sync value.
            void * outArray,    // Sended array address. Can be NULL.
            size_t outLen,      // Sended array length. Can be 0.
            void ** inArray,    // Received array address pointer. Can be NULL.
            size_t * inLen      // Received array size pointer. Can be NULL.
        );

        // Barrier syncronization with other NM6403 on board.
    int ncl_boardSync( int value );

        // Barrier sync with host NC with array exchange.
    int ncl_boardSyncArray( 
            int value,          // Sync value.
            void * outArray,    // Sended array address. Can be NULL.
            size_t outLen,      // Sended array length. Can be 0.
            void ** inArray,    // Received array address pointer. Can be NULL.
            size_t * inLen      // Received array size pointer. Can be NULL.
        );

};

#endif // _NC_LOAD_H
