//----------------------------------------------------------------------//
//                                                                      //
//                     Neuroprocessor NM6403 SDK v. 1.20                //
//                                                                      //
//                              Demo program                            //
//             that use low level library to handle interrupts          //
//                                                                      //
//                 1999 (c) RC Module Inc., Moscow, Russia              //
//                                                                      //
//----------------------------------------------------------------------//

//
// test_int.c
// Example program use interrupt handler
//

#include "nc_int.h"

extern "C" {
  void int_handler( void );
};

int n = 0;
int resultBuffer[10] = { 0 };

int main()
{
        // Set interrupt handler
    SetInterrupt ( INTT1, int_handler );

        // Save old interrupt mask.
    int InterruptMask = GetInterruptMask();

        // Enable all interrupts, except for step-by-step interrupt.
    EnableInterrupts( MIALL & ~(MISTEP) );

        // Raise timer 1 interrupt.
    SetTimerCounter( 1, -1 );
    SetTimerCtrl( 1 );


        // Restore old interrupt mask.
    DisableInterrupts( InterruptMask );

    return n;
}

void int_handler()
{
    // Write interrupt flag.
  resultBuffer[n] = n+1;

    // Increment interrupt counter.
  n++;
}
